#include <bits/stdc++.h>
#define ll long long
using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll ans = 0;
    multiset <int> st;
    ll sum = 0;
    for (int i = 0; i < k - 1; i++) {
        st.insert(a[i]);
        sum += a[i];
    }
    for (int i = k - 1; i < n; i++) {
        ans = max(ans, sum + a[i] + i + 1);
        if (k != 1) {
            int x = *st.begin();
            if (x < a[i]) {
                st.erase(st.find(x));
                sum -= x;
                sum += a[i];
                st.insert(a[i]);
            }
        }
    }
    cout << ans;
}
